#####################################################################
# File: ecmb_enums.py
# Copyright (c) 2023 Clemens K. (https://github.com/metacreature)
# 
# MIT License
# 
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
# 
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
# 
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
#####################################################################

from enum import Enum

class ALLOWED_IMAGE_EXTENTIONS(Enum):
    """ALLOWED_IMAGE_EXTENTIONS 
    
    * JPG = 'jpg'
    * JPEG = 'jpeg'
    * PNG = 'png'
    * WEBP = 'webp'
    """    
    JPG = 'jpg'
    JPEG = 'jpeg'
    PNG = 'png'
    WEBP = 'webp'


class BOOK_TYPE(Enum):
    """BOOK_TYPE 
    
    * MANGA = 'manga'
    * COMIC = 'comic'
    """    
    MANGA = 'manga'
    COMIC = 'comic'


class BASED_ON_TYPE(Enum):
    """BASED_ON_TYPE 

    * NOVEL = 'Novel'
    * LIGHTNOVEL = 'Lightnovel'
    * MANGA = 'Manga'
    * COMIC = 'Comic'
    * ANIME = 'Anime'
    * GAME = 'Game'
    * OTHER ='Other'
    """    
    NOVEL = 'Novel'
    LIGHTNOVEL = 'Lightnovel'
    MANGA = 'Manga'
    COMIC = 'Comic'
    ANIME = 'Anime'
    GAME = 'Game'
    OTHER ='Other'
    

class AUTHOR_ROLE(Enum):
    """AUTHOR_ROLE 
    
    * AUTHOR = 'Author'
    * COAUTHOR = 'Co-Author'
    * STORY = 'Story'
    * ART = 'Art'
    * COLORIST = 'Colorist'
    * COVERARTIST = 'CoverArtist'
    """    
    AUTHOR = 'Author'
    COAUTHOR = 'Co-Author'
    STORY = 'Story'
    ART = 'Art'
    COLORIST = 'Colorist'
    COVERARTIST = 'CoverArtist'


class EDITOR_ROLE(Enum):
    """EDITOR_ROLE 
    
    * TRANSLATOR = 'Translator'
    * SCANNER = 'Scanner'
    """    
    TRANSLATOR = 'Translator'
    SCANNER = 'Scanner'


class CONTENT_WARNING(Enum):
    """CONTENT_WARNING 
    
    * ADULT = 'Adult'
    * MATURE_THEMES = 'Mature Themes'
    * NUDITY = 'Nudity'
    * SEXUAL_CONTENT = 'Sexual Content'
    * EXPLICIT_SEX = 'Explict Sex'
    * HENTAI = 'Hentai'
    * PROSTITUTION = 'Prostitution'
    * INCEST = 'Incest'
    * VIOLENCE = 'Violence'
    * EXPLICIT_VIOLENCE = 'Explicit Violence'
    * TERRORISM = 'Terrorism'
    * EMOTIONAL_ABUSE= 'Emotional Abuse'
    * SEXUAL_ABUSE = 'Sexual Abuse'
    * PHYSICAL_ABUSE = 'Physical Abuse'
    * DOMESTIC_ABUSE = 'Domestic Abuse'
    * SELF_HARM = 'Self-Harm'
    * SUICIDE = 'Suicide'
    * DRUGS = 'Drugs'
    """
    ADULT = 'Adult'
    MATURE_THEMES = 'Mature Themes'
    NUDITY = 'Nudity'
    SEXUAL_CONTENT = 'Sexual Content'
    EXPLICIT_SEX = 'Explict Sex'
    HENTAI = 'Hentai'
    PROSTITUTION = 'Prostitution'
    INCEST = 'Incest'
    VIOLENCE = 'Violence'
    EXPLICIT_VIOLENCE = 'Explicit Violence'
    TERRORISM = 'Terrorism'
    EMOTIONAL_ABUSE= 'Emotional Abuse'
    SEXUAL_ABUSE = 'Sexual Abuse'
    PHYSICAL_ABUSE = 'Physical Abuse'
    DOMESTIC_ABUSE = 'Domestic Abuse'
    SELF_HARM = 'Self-Harm'
    SUICIDE = 'Suicide'
    DRUGS = 'Drugs'


class TARGET_SIDE(Enum):
    """TARGET_SIDE 

    * AUTO = 'auto'
    * LEFT = 'left'
    * RIGHT = 'right'
    """    
    AUTO = 'auto'
    LEFT = 'left'
    RIGHT = 'right'


class LANGUAGE_CODE(Enum):
    """LANGUAGE_CODE
    * Afar = 'aa'
    * Abkhaz = 'ab'
    * Avestan = 'ae'
    * Afrikaans = 'af'
    * Akan = 'ak'
    * Amharic = 'am'
    * Aragonese = 'an'
    * Arabic = 'ar'
    * Assamese = 'as'
    * Avaric = 'av'
    * Aymara = 'ay'
    * Azerbaijani = 'az'
    * Bashkir = 'ba'
    * Belarusian = 'be'
    * Bulgarian = 'bg'
    * Bislama = 'bi'
    * Bambara = 'bm'
    * Bengali = 'bn'
    * Tibetan = 'bo'
    * Breton = 'br'
    * Bosnian = 'bs'
    * Catalan = 'ca'
    * Chechen = 'ce'
    * Chamorro = 'ch'
    * Corsican = 'co'
    * Cree = 'cr'
    * Czech = 'cs'
    * Old_Church_Slavonic = 'cu'
    * Chuvash = 'cv'
    * Welsh = 'cy'
    * Danish = 'da'
    * German = 'de'
    * Divehi = 'dv'
    * Dzongkha = 'dz'
    * Ewe = 'ee'
    * Greek = 'el'
    * English = 'en'
    * Esperanto = 'eo'
    * Spanish = 'es'
    * Estonian = 'et'
    * Basque = 'eu'
    * Persian = 'fa'
    * Fula = 'ff'
    * Finnish = 'fi'
    * Fijian = 'fj'
    * Faroese = 'fo'
    * French = 'fr'
    * Western_Frisian = 'fy'
    * Irish = 'ga'
    * Scottish_Gaelic = 'gd'
    * Galician = 'gl'
    * Guaraní = 'gn'
    * Gujarati = 'gu'
    * Manx = 'gv'
    * Hausa = 'ha'
    * Hebrew = 'he'
    * Hindi = 'hi'
    * Hiri_Motu = 'ho'
    * Croatian = 'hr'
    * Haitian = 'ht'
    * Hungarian = 'hu'
    * Armenian = 'hy'
    * Herero = 'hz'
    * Interlingua = 'ia'
    * Indonesian = 'id'
    * Interlingue = 'ie'
    * Igbo = 'ig'
    * Nuosu = 'ii'
    * Inupiaq = 'ik'
    * Ido = 'io'
    * Icelandic = 'is'
    * Italian = 'it'
    * Inuktitut = 'iu'
    * Japanese = 'ja'
    * Javanese = 'jv'
    * Georgian = 'ka'
    * Kongo = 'kg'
    * Kikuyu = 'ki'
    * Kwanyama = 'kj'
    * Kazakh = 'kk'
    * Kalaallisut = 'kl'
    * Khmer = 'km'
    * Kannada = 'kn'
    * Korean = 'ko'
    * Kanuri = 'kr'
    * Kashmiri = 'ks'
    * Kurdish = 'ku'
    * Komi = 'kv'
    * Cornish = 'kw'
    * Kyrgyz = 'ky'
    * Latin = 'la'
    * Luxembourgish = 'lb'
    * Ganda = 'lg'
    * Limburgish = 'li'
    * Lingala = 'ln'
    * Lao = 'lo'
    * Lithuanian = 'lt'
    * Luba_Katanga = 'lu'
    * Latvian = 'lv'
    * Malagasy = 'mg'
    * Marshallese = 'mh'
    * Māori = 'mi'
    * Macedonian = 'mk'
    * Malayalam = 'ml'
    * Mongolian = 'mn'
    * Marathi = 'mr'
    * Malay = 'ms'
    * Maltese = 'mt'
    * Burmese = 'my'
    * Nauru = 'na'
    * Norwegian_Bokmål = 'nb'
    * Northern_Ndebele = 'nd'
    * Nepali = 'ne'
    * Ndonga = 'ng'
    * Dutch = 'nl'
    * Norwegian_Nynorsk = 'nn'
    * Norwegian = 'no'
    * Southern_Ndebele = 'nr'
    * Navajo = 'nv'
    * Chichewa = 'ny'
    * Occitan = 'oc'
    * Ojibwe = 'oj'
    * Oromo = 'om'
    * Oriya = 'or'
    * Ossetian = 'os'
    * Panjabi = 'pa'
    * Pāli = 'pi'
    * Polish = 'pl'
    * Pashto = 'ps'
    * Portuguese = 'pt'
    * Quechua = 'qu'
    * Romansh = 'rm'
    * Kirundi = 'rn'
    * Romanian = 'ro'
    * Russian = 'ru'
    * Kinyarwanda = 'rw'
    * Sanskrit = 'sa'
    * Sardinian = 'sc'
    * Sindhi = 'sd'
    * Northern_Sami = 'se'
    * Sango = 'sg'
    * Sinhala = 'si'
    * Slovak = 'sk'
    * Slovenian = 'sl'
    * Samoan = 'sm'
    * Shona = 'sn'
    * Somali = 'so'
    * Albanian = 'sq'
    * Serbian = 'sr'
    * Swati = 'ss'
    * Southern_Sotho = 'st'
    * Sundanese = 'su'
    * Swedish = 'sv'
    * Swahili = 'sw'
    * Tamil = 'ta'
    * Telugu = 'te'
    * Tajik = 'tg'
    * Thai = 'th'
    * Tigrinya = 'ti'
    * Turkmen = 'tk'
    * Tagalog = 'tl'
    * Tswana = 'tn'
    * Tonga = 'to'
    * Turkish = 'tr'
    * Tsonga = 'ts'
    * Tatar = 'tt'
    * Twi = 'tw'
    * Tahitian = 'ty'
    * Uyghur = 'ug'
    * Ukrainian = 'uk'
    * Urdu = 'ur'
    * Uzbek = 'uz'
    * Venda = 've'
    * Vietnamese = 'vi'
    * Volapük = 'vo'
    * Walloon = 'wa'
    * Wolof = 'wo'
    * Xhosa = 'xh'
    * Yiddish = 'yi'
    * Yoruba = 'yo'
    * Zhuang = 'za'
    * Chinese = 'zh'
    * Zulu = 'zu'
    """

    Afar = 'aa'
    Abkhaz = 'ab'
    Avestan = 'ae'
    Afrikaans = 'af'
    Akan = 'ak'
    Amharic = 'am'
    Aragonese = 'an'
    Arabic = 'ar'
    Assamese = 'as'
    Avaric = 'av'
    Aymara = 'ay'
    Azerbaijani = 'az'
    Bashkir = 'ba'
    Belarusian = 'be'
    Bulgarian = 'bg'
    Bislama = 'bi'
    Bambara = 'bm'
    Bengali = 'bn'
    Tibetan = 'bo'
    Breton = 'br'
    Bosnian = 'bs'
    Catalan = 'ca'
    Chechen = 'ce'
    Chamorro = 'ch'
    Corsican = 'co'
    Cree = 'cr'
    Czech = 'cs'
    Old_Church_Slavonic = 'cu'
    Chuvash = 'cv'
    Welsh = 'cy'
    Danish = 'da'
    German = 'de'
    Divehi = 'dv'
    Dzongkha = 'dz'
    Ewe = 'ee'
    Greek = 'el'
    English = 'en'
    Esperanto = 'eo'
    Spanish = 'es'
    Estonian = 'et'
    Basque = 'eu'
    Persian = 'fa'
    Fula = 'ff'
    Finnish = 'fi'
    Fijian = 'fj'
    Faroese = 'fo'
    French = 'fr'
    Western_Frisian = 'fy'
    Irish = 'ga'
    Scottish_Gaelic = 'gd'
    Galician = 'gl'
    Guaraní = 'gn'
    Gujarati = 'gu'
    Manx = 'gv'
    Hausa = 'ha'
    Hebrew = 'he'
    Hindi = 'hi'
    Hiri_Motu = 'ho'
    Croatian = 'hr'
    Haitian = 'ht'
    Hungarian = 'hu'
    Armenian = 'hy'
    Herero = 'hz'
    Interlingua = 'ia'
    Indonesian = 'id'
    Interlingue = 'ie'
    Igbo = 'ig'
    Nuosu = 'ii'
    Inupiaq = 'ik'
    Ido = 'io'
    Icelandic = 'is'
    Italian = 'it'
    Inuktitut = 'iu'
    Japanese = 'ja'
    Javanese = 'jv'
    Georgian = 'ka'
    Kongo = 'kg'
    Kikuyu = 'ki'
    Kwanyama = 'kj'
    Kazakh = 'kk'
    Kalaallisut = 'kl'
    Khmer = 'km'
    Kannada = 'kn'
    Korean = 'ko'
    Kanuri = 'kr'
    Kashmiri = 'ks'
    Kurdish = 'ku'
    Komi = 'kv'
    Cornish = 'kw'
    Kyrgyz = 'ky'
    Latin = 'la'
    Luxembourgish = 'lb'
    Ganda = 'lg'
    Limburgish = 'li'
    Lingala = 'ln'
    Lao = 'lo'
    Lithuanian = 'lt'
    Luba_Katanga = 'lu'
    Latvian = 'lv'
    Malagasy = 'mg'
    Marshallese = 'mh'
    Māori = 'mi'
    Macedonian = 'mk'
    Malayalam = 'ml'
    Mongolian = 'mn'
    Marathi = 'mr'
    Malay = 'ms'
    Maltese = 'mt'
    Burmese = 'my'
    Nauru = 'na'
    Norwegian_Bokmål = 'nb'
    Northern_Ndebele = 'nd'
    Nepali = 'ne'
    Ndonga = 'ng'
    Dutch = 'nl'
    Norwegian_Nynorsk = 'nn'
    Norwegian = 'no'
    Southern_Ndebele = 'nr'
    Navajo = 'nv'
    Chichewa = 'ny'
    Occitan = 'oc'
    Ojibwe = 'oj'
    Oromo = 'om'
    Oriya = 'or'
    Ossetian = 'os'
    Panjabi = 'pa'
    Pāli = 'pi'
    Polish = 'pl'
    Pashto = 'ps'
    Portuguese = 'pt'
    Quechua = 'qu'
    Romansh = 'rm'
    Kirundi = 'rn'
    Romanian = 'ro'
    Russian = 'ru'
    Kinyarwanda = 'rw'
    Sanskrit = 'sa'
    Sardinian = 'sc'
    Sindhi = 'sd'
    Northern_Sami = 'se'
    Sango = 'sg'
    Sinhala = 'si'
    Slovak = 'sk'
    Slovenian = 'sl'
    Samoan = 'sm'
    Shona = 'sn'
    Somali = 'so'
    Albanian = 'sq'
    Serbian = 'sr'
    Swati = 'ss'
    Southern_Sotho = 'st'
    Sundanese = 'su'
    Swedish = 'sv'
    Swahili = 'sw'
    Tamil = 'ta'
    Telugu = 'te'
    Tajik = 'tg'
    Thai = 'th'
    Tigrinya = 'ti'
    Turkmen = 'tk'
    Tagalog = 'tl'
    Tswana = 'tn'
    Tonga = 'to'
    Turkish = 'tr'
    Tsonga = 'ts'
    Tatar = 'tt'
    Twi = 'tw'
    Tahitian = 'ty'
    Uyghur = 'ug'
    Ukrainian = 'uk'
    Urdu = 'ur'
    Uzbek = 'uz'
    Venda = 've'
    Vietnamese = 'vi'
    Volapük = 'vo'
    Walloon = 'wa'
    Wolof = 'wo'
    Xhosa = 'xh'
    Yiddish = 'yi'
    Yoruba = 'yo'
    Zhuang = 'za'
    Chinese = 'zh'
    Zulu = 'zu'
  